﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Defining Dynamic Attributes at Run Time</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Defining Dynamic Attributes at Run Time</h1>
        <p>The <strong>Analytics</strong> module enables you to define SQL queries to obtain the required information from the database. You can add both static and dynamic attribute values in the WHERE condition of the query. Static attribute values are pre-defined to return specific results. The Dynamic attributes add flexibility to change the filter condition values passed in the queries at run time for varied results. Unlike static attributes, dynamic attributes are not embedded in your SQL query. Instead, they are entered from the user interface while creating the Analytics configuration and built by the query at run time. Support for dynamic attributes is available for both Elasticsearch and non-Elasticsearch run time analytics. For SQL Query based controls, although dynamic attributes can be configured, the control is always executed with the default value of the saved dynamic attribute while creating or editing the reports. While running SQL query based controls, users will not be prompted to enter the dynamic value</p>
        <p>Below is a sample SQL query containing dynamic attributes.</p>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city='${city}'and employeetype='${etype}':   </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>This example will query the <strong>users</strong> table for users by <strong>username</strong>, <strong>firstname</strong>, and <strong>lastname </strong>fieldswhile allowing you to define multiple values for <strong>city</strong> and <strong>etype</strong> at run time.</p>
        <p>You can define dynamic attributes at run time in both merged and non-merged interface.</p>
        <h2 id="DefiningDynamicAttributesatRunTime-DefiningDynamicAttributesatRunTime">Defining Dynamic Attributes at Run Time</h2>
        <p>To define dynamic attributes during run time, you must perform the following tasks in sequence for both Elasticsearch and non-Elasticsearch run time analytics:</p>
        <ol>
            <li>
                <p>Add dynamic attributes to the SQL query</p>
            </li>
            <li>
                <p>Define dynamic attribute values</p>
            </li>
            <li>
                <p>Edit the query</p>
            </li>
            <li>
                <p>Run the query</p>
            </li>
        </ol>
        <h3 id="DefiningDynamicAttributesatRunTime-AddingDynamicAttributesinElasticsearchRuntimeAnalytics">Adding Dynamic Attributes in Elasticsearch Runtime Analytics</h3>
        <p>Perform the following steps to add dynamic attributes:</p>
        <ol>
            <li>
                <p>Log in to IGA, select <strong>Analytics &gt; Analytics Configurations List</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Analytics Configurations Version 2</strong> page that displays, click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics (v2)</strong> window that displays, select <strong>Using SQL Query</strong>.</p>
                <p>
                    <img src="../Resources/Images/create new analytics - v2.png" style="width: 441px;height: 348px;border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>page that displays, enter an SQL query in <strong>Analytics Query </strong>and ensure that all mandatory fields are defined. <br />For more information about the fields, see <MadCap:xref href="Creating-Elasticsearch-based-Analytics-Control-V2-using-SQL-Query.htm">Creating Elasticsearch based Analytics Control (V2) using SQL Query.</MadCap:xref><br />For example, </p>
            </li>
        </ol>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city='${city}'and employeetype='${etype}': </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <ol MadCap:continue="true">
            <li>
                <p>Enable <strong>Runtime Analytics</strong>.</p>
                <p>
                    <img src="../Resources/Images/enable runtime analytics.jpg" />
                </p>
            </li>
            <li>
                <p>Click <strong>Create.</strong></p>
            </li>
            <li>
                <p>In the <strong>Add Attribute</strong> window that displays, view the <strong>city</strong> and <strong>etype</strong> dynamic attributes that you defined in the <strong>Analytics Query</strong> field.</p>
                <p>
                    <img src="../Resources/Images/add attribute - edit.jpg" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                    <p class="note">If you select <strong>Preview </strong>button, the attribute values that you enter in the <strong>Add Attribute</strong> window are not saved.</p>
                </div>
            </li>
        </ol>
        <h3 id="DefiningDynamicAttributesatRunTime-AddingDynamicAttributesinNon-ElasticsearchRuntimeAnalytics">Adding Dynamic Attributes in Non-Elasticsearch Runtime Analytics</h3>
        <p>Perform the following steps to add dynamic attributes:</p>
        <ol>
            <li>
                <p>Log in to IGA, select <strong>Analytics &gt; Analytics Configurations List &gt; Version 1.</strong></p>
            </li>
            <li>
                <p>In the <strong>Analytics Configurations Version 1</strong> page that displays, click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>window that displays, select <b>Runtime Analytics</b>.</p>
                <p>
                    <img src="../Resources/Images/create new analytics - v1.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>page that displays, enter an SQL query in <strong>Analytics Query </strong>and ensure that all mandatory fields are defined.<br />For more information about fields, see <MadCap:xref href="Creating-Runtime-Analytics-Control.htm">Creating Runtime Analytics Control</MadCap:xref>.<br />For example, </p>
                <MadCap:codeSnippet>
                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city='${city}'and employeetype='${etype}':   </MadCap:codeSnippetBody>
                </MadCap:codeSnippet>
            </li>
            <li>
                <p>Click <strong>Create.</strong><br />In the <strong>Add Attribute</strong> window that displays, view the <strong>city</strong> and <strong>etype</strong> dynamic attributes that you defined in the <strong>Analytics Query</strong> field.</p>
                <p>
                    <img src="../Resources/Images/add attribute - edit.jpg" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                    <p class="note">If you select <strong>Preview </strong>button, the attribute values that you enter in the <strong>Add Attribute</strong> window are not saved.</p>
                </div>
            </li>
        </ol>
        <h3 id="DefiningDynamicAttributesatRunTime-AddingDynamicAttributesinMergedInterface">Adding Dynamic Attributes in Merged Interface</h3>
        <p>Perform the following steps to add dynamic attributes:</p>
        <ol>
            <li>
                <p>Log in to IGA, select <strong> Analytics &gt; Analytics Configurations List</strong>.</p>
            </li>
            <li>
                <p>Click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>window that displays, select <strong>Runtime Analytics</strong>.</p>
                <p>
                    <img src="../Resources/Images/Create New Analytics (merged interface).png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>page that displays, enter an SQL query in <strong>Analytics Query </strong>and ensure that all mandatory fields are defined.<br />For more information about fields, see <MadCap:xref href="Creating-Runtime-Analytics-Control.htm">Creating Runtime Analytics Control</MadCap:xref>.<br />For example, </p>
            </li>
        </ol>
        <MadCap:codeSnippet>
            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city='${city}'and employeetype='${etype}':  </MadCap:codeSnippetBody>
        </MadCap:codeSnippet>
        <p>5. Click <strong>Create.</strong></p>
        <p>6. In the <strong>Add Attribute</strong> window that displays, view the <strong>city</strong> and <strong>etype</strong> dynamic attributes that you defined in the <strong>Analytics Query</strong> field.</p>
        <p>
            <img src="../Resources/Images/add attribute - edit.jpg" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
        </p>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">If you select the <b>Preview</b> button, the attribute values that you enter in the Add Attribute window are not saved.</p>
        </div>
        <h3 id="DefiningDynamicAttributesatRunTime-DefiningDynamicAttributes">Defining Dynamic Attributes</h3>
        <p>Perform the following steps to define dynamic attributes:</p>
        <ol>
            <li>
                <p>Go to the <strong>Add Attributes </strong>window and specify the following details:</p>
            </li>
        </ol>
        <div class="table-wrap">
            <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
                <col style="width: 158.0px;" class="TableStyle-Default-Table-Column-Column1" />
                <col style="width: 520.0px;" class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Field Name</th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Attribute Name</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Name of the attribute that you specified between the dollar sign and brackets <span class="inline-comment-marker">${ </span>} in <strong>Analytics Query </strong>in the <strong>Create New Analytics</strong> page.</p>
                            <p class="table-text">This is a read-only field.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Attribute Label</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Enter a display name for the attribute value.</p>
                            <p class="table-text">The <strong>Other Attributes </strong>field in the <strong>Show Analytics</strong> page displays the attribute names based on this value.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Order Index</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the order in which you want to view the fields if multiple dynamic attributes are specified in the SQL query.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Attribute Type</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify an attribute type.</p>
                            <p class="table-text">The options are:</p>
                            <ul>
                                <li>
                                    <p class="table-text"><strong>Enum</strong> - Allows you to pre-define multiple values of enumerated type. However, you can select only one value at run time.<br />For example, if you add Mumbai, Chennai, and Bengaluru as values, you can select only one value in the <strong>Values</strong> field in the <strong>Run Now</strong> option.</p>
                                </li>
                            </ul>
                            <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                <p class="note">Review the following guidelines when specifying <strong>Enum</strong>:</p>
                                <ul>
                                    <li>
                                        <p class="note">Enter the values as commas-separated without an empty space after the comma. For example, Mumbai,Chennai,Bengaluru</p>
                                    </li>
                                    <li>
                                        <p class="note">Ensure that you enter a default value.</p>
                                    </li>
                                </ul>
                            </div>
                            <ul>
                                <li>
                                    <p class="table-text"><strong>Multiple Select from List</strong> - Allows you to pre-define multiple values. You can select multiple values at run time. <br />For example, if you add Mumbai, Chennai, and Bengaluru as values, you can select multiple values in the <strong>Values</strong> field in the <strong>Run Now</strong> option.</p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>Number</strong> - Allows you to specify an integer value at run time.</p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>String</strong> - Allows you to specify alphabetic or alphanumeric characters at run time.</p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>Date</strong> – Allows you to choose a date using a date picker at run time. (available with 5.5.2 release and later in the merged interface)<br />For example, if you specify<br /></p>
                                    <MadCap:codeSnippet>
                                        <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                        <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                        <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, createddate from users where startdate=‘${sdate}’and enddate='${edate}': </MadCap:codeSnippetBody>
                                    </MadCap:codeSnippet>
                                    <p class="table-text">in the query, you will see the values as shown in the figure below.</p>
                                    <p class="table-text">
                                        <img src="../Resources/Images/Add Attribute-choose a date value.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                    </p>
                                    <p class="table-text">Figure: Add Attribute-choose a date value<br /></p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>Single Select from SQL Query</strong> – Allows you to provide objects (such as users, accounts, entitlements, endpoints) in the <strong>Analytics Query</strong>. </p>
                                    <div class="info" MadCap:conditions="Default.v55X">
                                        <p class="note">This option is available from the Release v5.5.2 release and later in the merged interface.<br /></p>
                                    </div>
                                    <p class="table-text">For example</p>
                                    <ul>
                                        <li>
                                            <p>If you specify the following SQL</p>
                                            <MadCap:codeSnippet>
                                                <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                                <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                                <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, owner from users where owner in (${owner})   </MadCap:codeSnippetBody>
                                            </MadCap:codeSnippet>
                                            <p class="table-text">in the query, you will see the values as shown in the figure below.</p>
                                            <p class="table-text">
                                                <img src="../Resources/Images/Edit Attribute-choose values from SQL query.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                            </p>
                                            <p class="table-text">Figure: Edit Attribute-choose values from SQL query</p>
                                        </li>
                                        <li>
                                            <p class="table-text">To fetch the username of the logged-in user, specify the following in the query.</p>
                                        </li>
                                    </ul>
                                </li>
                            </ul>
                            <MadCap:codeSnippet>
                                <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select u.username as ID from Users u where u.userkey = ${requestor} </MadCap:codeSnippetBody>
                            </MadCap:codeSnippet>
                            <ul>
                                <li>
                                    <p class="table-text"><strong>SQL Query</strong> - Allows you to enter the SQL query at run time as shown in figure below. <br />For example, to obtain the&#160;distinct owner names from the database,&#160;&#160;specify the following  in the query.</p>
                                    <MadCap:codeSnippet>
                                        <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                        <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                        <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select distinct owner from users</MadCap:codeSnippetBody>
                                    </MadCap:codeSnippet>
                                    <p>
                                        <img src="../Resources/Images/Edit Attribute-Add SQL query.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                    </p>
                                    <p>Figure: Edit Attribute-Add SQL query</p>
                                </li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Values</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the values of the attributes that you want to add.</p>
                            <p class="table-text">You can add one or multiple values based on the <strong>Attribute Type </strong>that you selected.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">Default Values</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <p class="table-text">Specify the default values of attributes to use at run time.</p>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <p>2. Click <strong>Save</strong> to save the changes.<br />3. In the <strong>Columns to show </strong>window that displays, do the following:</p>
        <p style="margin-left: 30.0px;">a. In the<strong> Visible</strong> column, deselect the check box for each attribute to hide the corresponding value at run time.<br />b. In the <strong>Filterable</strong> column, deselect the check box for each attribute to make the attribute non-filterable at run time.</p>
        <p>4. Click <strong>Submit</strong>.</p>
        <p>The dynamic attribute labels along with the default values that you defined in this procedure are displayed under Other Attributes section in the <strong>Analytics Configuration Details</strong> page.</p>
        <h3 id="DefiningDynamicAttributesatRunTime-EditingtheAttributes">Editing the Attributes</h3>
        <p>Perform the following steps to edit the attributes:</p>
        <ol>
            <li>
                <p>Go to <strong>Analytics Configuration List </strong>page, then go to the query that you created and click <strong>Edit</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Edit Analytics Configuration</strong> page that displays, click <strong>Edit Attribute</strong>. </p>
            </li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">The changes that you make are instantly&#160;shown&#160;in the&#160;<strong>Other Attributes</strong>&#160;section.</p>
        </div>
        <p>3. In the <strong>Edit Attribute </strong>window that displays, change the attribute values.</p>
        <p>4. Click <strong>Update</strong>.</p>
        <h3 id="DefiningDynamicAttributesatRunTime-RunningtheQuery">Running the Query</h3>
        <p>Perform the following steps to run the query:</p>
        <ol>
            <li>
                <p>Go to <strong>Analytics Configuration List </strong>page, then go to the query that you created and click <strong>Run &gt; Run Now</strong>. <br />Or <br />Go to the <strong>Analytics Configuration Details</strong> page and click <strong>Run &gt; Run Now</strong>.</p>
            </li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">Ensure that the values specified for the attributes are in-sync with the database values. </p>
        </div>
        <ol MadCap:continue="true">
            <li>
                <p>In the <strong>Analytics History</strong> page that displays, view the values obtained from the database.</p>
            </li>
        </ol>
        <h2 id="DefiningDynamicAttributesatRunTime-DefiningDynamicAttributesforSQLQuerybasedControls">Defining Dynamic Attributes for SQL Query based Controls</h2>
        <p>To define dynamic attributes during query creation, you must perform the following tasks in sequence for both Elasticsearch and non-Elasticsearch run time analytics:</p>
        <ol>
            <li>
                <p>Add dynamic attributes to the SQL query</p>
            </li>
            <li>
                <p>Run the query</p>
            </li>
        </ol>
        <h3 id="DefiningDynamicAttributesatRunTime-AddingDynamicAttributesinElasticsearchRuntimeAnalytics.1">Adding Dynamic Attributes in Elasticsearch Runtime Analytics</h3>
        <p>Perform the following steps to add dynamic attributes:</p>
        <ol>
            <li>
                <p>Log in to IGA, select <strong>Analytics &gt; Analytics Configurations List</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Analytics Configurations Version 2</strong> page that displays, click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics (v2)</strong> window that displays, select <strong>Using SQL Query</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>page that displays, enter an SQL query in <strong>Analytics Query </strong>and ensure that all mandatory fields are defined. <br />For more information about the fields, see <MadCap:xref href="Creating-Elasticsearch-based-Analytics-Control-V2-using-SQL-Query.htm">Creating Elasticsearch based Analytics Control (V2) using SQL Query</MadCap:xref>.<br />For example, </p>
                <MadCap:codeSnippet>
                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city1=‘${city1}’and city2='${city2}':  </MadCap:codeSnippetBody>
                </MadCap:codeSnippet>
            </li>
            <li>
                <p>Ensure that the <strong>Runtime Analytics </strong>field is disabled.</p>
                <p>
                    <img src="../Resources/Images/disable runtime analytics.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
            </li>
            <li>
                <p>Click <strong>Create.</strong></p>
            </li>
            <li>
                <p>In the <strong>Add Attribute</strong> window that displays, view the <strong>city1</strong> and <strong>city2</strong> dynamic attributes that you defined in the <strong>Analytics Query</strong> field.</p>
            </li>
        </ol>
        <p>
            <img src="../Resources/Images/add attribute - string.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
        </p>
        <h3 id="DefiningDynamicAttributesatRunTime-AddingDynamicAttributesinNon-ElasticsearchRuntimeAnalytics.1">Adding Dynamic Attributes in Non-Elasticsearch Runtime Analytics</h3>
        <p>Perform the following steps to add dynamic attributes:</p>
        <ol>
            <li>
                <p>Log in to IGA, select <strong>Analytics &gt; Analytics Configurations List &gt; Version 1</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Analytics Configurations Version 1</strong> page that displays, click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>window that displays, select <strong>Using SQL Query</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Create New Analytics </strong>page that displays, enter an SQL query in <strong>Analytics Query </strong>and ensure that all mandatory fields are defined.<br />For more information about fields, <MadCap:xref href="Creating-Analytics-Control-V1-using-SQL-Query.htm">Creating Analytics Control (V1) using SQL Query.</MadCap:xref><br />For example, </p>
                <MadCap:codeSnippet>
                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username, firstname, lastname from users where city1=‘${city1}’and city2='${city2}':  </MadCap:codeSnippetBody>
                </MadCap:codeSnippet>
                <p>
                    <br />
                </p>
            </li>
            <li>
                <p>Click <strong>Create.</strong><br />In the <strong>Add Attribute</strong> window that displays, view the <strong>city1</strong> and <strong>city2</strong> dynamic attributes that you defined in the <strong>Analytics Query</strong> field.<br />In the <strong>Add Attribute</strong> window that displays, view the <strong>city</strong> and <strong>etype</strong> dynamic attributes that you defined in the <strong>Analytics Query</strong> field.</p>
                <p>
                    <img src="../Resources/Images/add attribute - string.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                </p>
            </li>
        </ol>
        <h3 id="DefiningDynamicAttributesatRunTime-RunningtheQuery.1">Running the Query</h3>
        <p>Perform the following steps to run the query:</p>
        <ol>
            <li>
                <p>Go to <strong>Analytics Configuration List </strong>page, then go to the query that you created and click <strong>Run &gt; Run Now</strong>. <br />Or <br />Go to the <strong>Analytics Configuration Details</strong> page and click <strong>Run &gt; Run Now</strong>.</p>
            </li>
            <li>
                <p>In the <strong>Analytics History</strong> page that displays, view the values obtained from the database.</p>
            </li>
        </ol>
        <p>&#160;</p>
    </body>
</html>